(function() {
    'use strict';

    var yeoman = require('yeoman-generator');

    module.exports = yeoman.generators.Base.extend({

        initializing: function () {
            // See if there is a name argument
            this.argument('className', { type: String, required: false });

            if (!this.className) {
                // Get from option
                this.className = this.options.className;
            }

            if (!this.className) {
                // Error out with required argument
                this.argument('className', { type: String, required: true });
            }
        },

        writing: {
            require: function () {
                this.fs.copyTpl(
                    this.templatePath('Class.js'),
                    this.destinationPath(this.className + '.js'),
                    {className: this.className}
                );
            }
        }

    });

})();