(function() {
    'use strict';

    var yeoman = require('yeoman-generator');

    // module.exports = yeoman.generators.NamedBase.extend({
    module.exports = yeoman.generators.Base.extend({

        initializing: function () {
            this.pkg = require('../../package.json');

            // See if there is a name argument
            this.argument('className', { type: String, required: false });

            if (!this.className) {
                // Get from option
                this.className = this.options.className;
            }

            if (!this.className) {
                // Error out with required argument
                this.argument('className', { type: String, required: true });
            }

            this._resolvers = {
                className: this.className,
                classNameLowercase: this.className.charAt(0).toLowerCase() + this.className.slice(1)
            };

        },

        writing: {
            require: function () {

                this.fs.copyTpl(
                    this.templatePath('spec/Class-global-spec.js'),
                    this.destinationPath('spec/' + this.className  + '-global-spec.js'),
                    this._resolvers
                );
                this.fs.copyTpl(
                    this.templatePath('spec/Class-spec.js'),
                    this.destinationPath('spec/' + this.className  + '-spec.js'),
                    this._resolvers
                );

                this.fs.copyTpl(
                    this.templatePath('test/source.html'),
                    this.destinationPath('test/source.html'),
                    this._resolvers
                );
                this.fs.copyTpl(
                    this.templatePath('test/dist.html'),
                    this.destinationPath('test/dist.html'),
                    this._resolvers
                );
                this.fs.copyTpl(
                    this.templatePath('test/dist-min.html'),
                    this.destinationPath('test/dist-min.html'),
                    this._resolvers
                );


            }
        }

    });

})();